/***************************************************************************
                          convertfile.cpp  -  description
                             -------------------
    begin                : mer nov 27 2002
    copyright            : (C) 2002 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmediagrab.h"
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qstring.h>
#include <qmultilineedit.h>
#include <qspinbox.h>
#include <kfiledialog.h>
#include <qlineedit.h>
#include <kprocess.h>
#include <klocale.h>
#include <krun.h>


void KMediaGrab::grabFileStart()
{

    ButtonFileStart->setDisabled(true);
    ButtonFileStop->setEnabled(true);
    BrowserFile->setText("");
    grabFileCmd.clearArguments();

    // Check for a valid file://
    if(LineFileOutput->text()=="" && LineFileInput->text()=="")
    {

          ButtonFileStart->setEnabled(true);
          ButtonFileStop->setDisabled(true);
          BrowserFile->append(i18n("no input or target file selected"));
          return;

    }

    grabFileCmd<<"mencoder"<<LineFileInput->text();

    if(CheckFileIdx->isChecked())
    {

        grabFileCmd<<"-idx";

    }
                                                                                                            //           ADD FILE VIDEO SETTINGS

    grabFileCmd<<"-ovc";

    switch(ComboFileVideoCodec->currentItem())
    {

        case 0:
                  grabFileCmd<<"lavc"<<"-lavcopts";

                  switch(ComboFileVideoCodecLavc->currentItem())
                  {

                      case 0:
                                stringFileVideo="vcodec=mpeg4";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                      case 1:
                                stringFileVideo="vcodec=msmpeg4";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                      case 2:
                                stringFileVideo="vcodec=mjpeg";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                      case 3:
                                stringFileVideo="vcodec=h263p";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                      case 4:
                                stringFileVideo="vcodec=rv10";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                      case 5:
                                stringFileVideo="vcodec=mpeg1video";
                                stringFileVideo+=":vbitrate=";
                                stringFileVideo+=SpinFileVideoBr->text();
                                break;

                  }

                  if (CheckFileLavcVhq->isChecked())
                  {

                      stringFileVideo+=":vhq";

                  }

                  grabFileCmd<<stringFileVideo;
                  break;

        case 1:
                  grabFileCmd<<"xvid"<<"-xvidencopts";
                  stringFileVideo="bitrate=";
                  stringFileVideo+=SpinFileVideoBr->text();
                  stringFileVideo+=":me_quality=";
                  fileDivxQuality.setNum(ComboFileDivx4Quality->currentItem());
                  stringFileVideo+=fileDivxQuality;
                  grabFileCmd<<stringFileVideo;
                  break;

        case 2:
                  grabFileCmd<<"copy";
                  break;

    }

    //ADD AUDIO SETTINGS

    if(!CheckFileNoaudio->isChecked())
    {

        grabFileCmd<<"-oac";

        switch(ComboFileAudioCodec->currentItem())
        {

              case 0:

                        grabFileCmd<<"mp3lame"<<"-lameopts";

                       switch(ComboFileAudioBitrateType->currentItem())
                       {

                           case 0:
                                     stringFileAudio="abr";
                                     stringFileAudio+=":aq=";
                                     abrFileAlgoQuality.setNum(ComboFileAlgoQuality->currentItem());
                                     stringFileAudio+=abrFileAlgoQuality;
                                     stringFileAudio+=":vol=";
                                     stringFileAudio+=SpinFileVolumeGain->text();
                                     stringFileAudio+=":br=";
                                     stringFileAudio+=ComboFileAudioBitrate->currentText();
                                     break;

                           case 1:
                                     stringFileAudio="cbr";
                                     stringFileAudio+=":aq=";
                                     cbrFileAlgoQuality.setNum(ComboFileAlgoQuality->currentItem());
                                     stringFileAudio+=cbrFileAlgoQuality;
                                     stringFileAudio+=":vol=";
                                     stringFileAudio+=SpinFileVolumeGain->text();
                                     stringFileAudio+=":br=";
                                     stringFileAudio+=ComboFileAudioBitrate->currentText();
                                     break;

                           case 2:
                                     stringFileAudio="vbr=";
                                     fileVbrType.setNum(ComboFileVbrType->currentItem());
                                     stringFileAudio+=fileVbrType;
                                     stringFileAudio+=":aq=";
                                     vbrFileAlgoQuality.setNum(ComboFileAlgoQuality->currentItem());
                                     stringFileAudio+=vbrFileAlgoQuality;
                                     stringFileAudio+=":vol=";
                                     stringFileAudio+=SpinFileVolumeGain->text();
                                     stringFileAudio+=":q=";
                                     fileVbrQuality.setNum(ComboFileVbrQuality->currentItem());
                                     stringFileAudio+=fileVbrQuality;
                                     break;

                       }

                       switch(ComboFileAudioMode->currentItem())
                       {

                              case 0:
                                        break;

                              case 1:
                                        stringFileAudio+=":mode=0";
                                        break;

                              case 2:
                                        stringFileAudio+=":mode=1";
                                        break;

                              case 3:
                                        stringFileAudio+=":mode=2";
                                        break;

                              case 4:
                                        stringFileAudio+=":mode=3";
                                        break;


                       }

                       grabFileCmd<<stringFileAudio;
                       break;

        case 1:
                  grabFileCmd<<"copy";
                  break;

        }

    }

    else
    {

        grabFileCmd<<"-nosound";

    }



                                                                                                                              //             VIDEO SCALING

    if(ComboFileVideoCodec->currentItem()!=2 && CheckFileVideoScale->isChecked())
    {

        grabFileCmd<<"-vop scale -zoom -xy"<<ComboFileScaleVideo->currentText();

    }

    grabFileCmd<<"-o"<<LineFileOutput->text();

    grabFileCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;
}

void KMediaGrab::grabFileGetStdout(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserFile->append( out );

}

void KMediaGrab::grabFileGetStderr(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserFile->append( out );

}

void KMediaGrab::grabFileProcessEnd( KProcess *)
{

    grabFileCmd.kill();
    ButtonFileStart->setEnabled(true);
    ButtonFileStop->setDisabled(true);

}

void KMediaGrab::grabFileStop()
{

    grabFileCmd.kill();
    ButtonFileStart->setEnabled(true);
    ButtonFileStop->setDisabled(true);

}


void KMediaGrab::switchFileVideoCodec(int VideoCodec)
{

    switch(VideoCodec)
    {

        case 0:
                  ComboFileVideoCodecLavc->setEnabled(true);
                  ComboFileDivx4Quality->setDisabled(true);
                  CheckFileLavcVhq->setEnabled(true);
                  SpinFileVideoBr->setEnabled(true);
                  CheckFileVideoScale->setEnabled(true);

                  if(CheckFileVideoScale->isChecked())
                  {

                      ComboFileScaleVideo->setEnabled(true);

                  }

                  break;

        case 1:
                  ComboFileVideoCodecLavc->setDisabled(true);
                  ComboFileDivx4Quality->setEnabled(true);
                  CheckFileLavcVhq->setDisabled(true);
                  SpinFileVideoBr->setEnabled(true);
                  CheckFileVideoScale->setEnabled(true);

                  if(CheckFileVideoScale->isChecked())
                  {

                      ComboFileScaleVideo->setEnabled(true);

                  }

                  break;

        case 2:
                  ComboFileVideoCodecLavc->setDisabled(true);
                  ComboFileDivx4Quality->setDisabled(true);
                  CheckFileLavcVhq->setDisabled(true);
                  SpinFileVideoBr->setDisabled(true);
                  CheckFileVideoScale->setDisabled(true);
                  ComboFileScaleVideo->setDisabled(true);
                  break;



    }

}

void KMediaGrab::switchFileAudioCodec(int AudioCodec)
{

    switch(AudioCodec)
    {

        case 0:
                  ComboFileAudioBitrateType->setEnabled(true);
                  ComboFileAudioBitrate->setEnabled(true);
                  ComboFileAlgoQuality->setEnabled(true);
                  SpinFileVolumeGain->setEnabled(true);
                  ComboFileAudioMode->setEnabled(true);
                  if( ComboFileAudioBitrateType->currentItem()==2)
                  {

                      ComboFileVbrType->setEnabled(true);
                      ComboFileVbrQuality->setEnabled(true);
                  }

                  break;

        case 1:
                  ComboFileAudioBitrateType->setDisabled(true);
                  ComboFileAudioBitrate->setDisabled(true);
                  ComboFileAlgoQuality->setDisabled(true);
                  SpinFileVolumeGain->setDisabled(true);
                  ComboFileAudioMode->setDisabled(true);
                  ComboFileVbrType->setDisabled(true);
                  ComboFileVbrQuality->setDisabled(true);
                  break;

    }

}

void KMediaGrab::toggleFileVbr(int BitrateType)
{

    switch(BitrateType)
    {

        case 0:
                  ComboFileVbrType->setDisabled(true);
                  ComboFileVbrQuality->setDisabled(true);
                  break;

        case 1:
                  ComboFileVbrType->setDisabled(true);
                  ComboFileVbrQuality->setDisabled(true);
                  break;

        case 2:
                  ComboFileVbrType->setEnabled(true);
                  ComboFileVbrQuality->setEnabled(true);
                  break;


    }

}

void KMediaGrab::toggleFileNoAudio(bool noAudio)
{

    if(noAudio)
    {

        ComboFileAudioBitrateType->setDisabled(true);
        ComboFileAudioBitrate->setDisabled(true);
        ComboFileAlgoQuality->setDisabled(true);
        SpinFileVolumeGain->setDisabled(true);
        ComboFileAudioMode->setDisabled(true);
        ComboFileVbrType->setDisabled(true);
        ComboFileVbrQuality->setDisabled(true);
        ComboFileAudioCodec->setDisabled(true);
    }

    else
    {

        ComboFileAudioBitrateType->setEnabled(true);
        ComboFileAudioBitrate->setEnabled(true);
        ComboFileAlgoQuality->setEnabled(true);
        SpinFileVolumeGain->setEnabled(true);
        ComboFileAudioMode->setEnabled(true);
        if( ComboFileAudioBitrateType->currentItem()==2)
        {

        ComboFileVbrType->setEnabled(true);
        ComboFileVbrQuality->setEnabled(true);
        }

        ComboFileAudioCodec->setEnabled(true);

    }

}

void KMediaGrab::getFileOutput()
{

    fileFileOutput = KFileDialog::getSaveFileName( QString::null , "*" , this , i18n("Save to..."));
    LineFileOutput->setText(fileFileOutput);

}

void KMediaGrab::playFileOutput()
{

    KRun* RunFile =new KRun(KURL(LineFileOutput->text()));

}



void KMediaGrab::toggleFileVideoScale()
{

    if(CheckFileVideoScale->isChecked())
    {

        ComboFileScaleVideo->setEnabled(true);

    }

    else

        ComboFileScaleVideo->setDisabled(true);

}

void KMediaGrab::getFileInput()
{

    fileFileInput = KFileDialog::getOpenFileName( QString::null , "*" , this , i18n("Choose file to convert..."));
    LineFileInput->setText(fileFileInput);

}





